#include <stdio.h>
#include <math.h>
#include <stdint.h>

#define SETTINGS 0b0001 << 4
#define CALC_SIZE 128
#define PI 3.1415

uint8_t values[CALC_SIZE][2];

void sine(){
    printf("uint8_t sine[][2] = {");

    for (int i = 0; i < CALC_SIZE; i++) {
        double rad = ((double) i / (double) CALC_SIZE) * (PI*2.f);
        
        double res = sin(rad);
        res += 1.f;

        uint16_t conversion = res * (4096/2);

        values[i][0] = SETTINGS | ((conversion >> 8) & 0b1111);
        values[i][1] = conversion & 0xff;

        printf("{%d, %d},", values[i][0], values[i][1]);
    }

    printf("};\n");
}

void triangle() {
    printf("uint8_t triangle[][2] = {");

    uint16_t val = 0;
    char dir = 1;
    for (int i = 0; i < CALC_SIZE; i++) {
        val += (4096/CALC_SIZE) * 2 * dir;

        if(val >= 4096)
            dir = -1;
        
        values[i][0] = SETTINGS | ((val >> 8) & 0b1111);
        values[i][1] = val & 0xff;

        printf("{%d, %d},", values[i][0], values[i][1]);
    }

    printf("};\n");
}

int main() {
    sine();
    triangle();

    return 0;
}
